unit FftDconvXMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls, system.Math,
  system.UITypes, Vcl.Grids, system.Types, system.DateUtils;

type
  D2array = array of array of Double;           // 񎟌f[^[p
  TDarray = array[0..0] of Double;              // zDouble
  PDarray = ^TDarray;                           // |C^[ zDouble錾
  M2array = array of integer;                   // zinteger
  TMarray = array[0..0] of integer;             // zinteger
  PMarray = ^TMarray;                           // |C^[ zinteger錾

  TForm1 = class(TForm)
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    MaskingBtn: TButton;
    RadioGroup1: TRadioGroup;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    SigumaGrid: TStringGrid;
    SigumaEdit: TLabeledEdit;
    sourceBtn: TButton;
    UnsharpEdit: TLabeledEdit;
    RangeEdit: TLabeledEdit;
    Timer1: TTimer;
    RepaintBtn: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    magnificationEdit: TLabeledEdit;
    GaussEdit: TLabeledEdit;
    TrimmingBtn: TButton;
    Memo1: TMemo;
    FulBtn: TButton;
    RadioGroup2: TRadioGroup;
    CheckBox1: TCheckBox;
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MaskingBtnClick(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
    procedure sourceBtnClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SigumaEditChange(Sender: TObject);
    procedure RangeEditChange(Sender: TObject);
    procedure RepaintBtnClick(Sender: TObject);
    procedure UnsharpEditChange(Sender: TObject);
    procedure TrimmingBtnClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FulBtnClick(Sender: TObject);
    procedure GaussEditChange(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Start;          // stopwatch strat
    function Stop: extended;  // stopwatch stop
    function SigumaMatSet: boolean;
    procedure FFT2(var a_rl, a_im: D2array; inv: Integer);
    procedure cstb(length: Integer; inv: integer; var sin_tbl, cos_tbl: array of double);
    procedure rvmtx(var a, b, c, d: D2array; xysize, yxsize: Integer);
    procedure LaplacianMask;
    procedure Imageout(Image: TBitmap);
    procedure GaussianRoutine;
    procedure Trimming;
    procedure TrimmingImage;
    procedure trimming_imageout(Image: TBitmap);
    procedure fft3(a_rl, a_im: PDarray; length, ex, inv: integer;
                          sin_tbl, cos_tbl: PDarray);
    procedure fft1core(a_rl, a_im: PDarray; length, ex: integer;
                    sin_tbl, cos_tbl, buf: PDarray; inv: integer);
    procedure birv(a: PDarray; length, ex: Integer; b: PDarray);
    procedure fft(a_rl, a_im: PDarray; var length, inv: integer;
                  sin_tbl, cos_tbl: PDarray; m: PMarray);
    procedure fft4(n, inv: integer; xr, xi, sin_tbl, cos_tbl: PDarray);
    procedure fftNo5(var n, ex, inv: integer; xr, xi, sin_tbl, cos_tbl: PDarray);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

  ImageHWC   = 440;                           // \gTCY

  gaus = 9;                                   // KEVAzTCY

  Laplacian     = 0;
  Gaussians     = 1;
  Deconvolution = 2;
  Unsharp       = 3;

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  SHeight       : Integer;                    // ̓f[^[摜
  SWidth        : Integer;                    // ̓f[^[摜
  GHeight       : Integer;                    // vZf[^[摜
  GWidth        : Integer;                    // vZf[^[摜
  THeight       : Integer;                    // g~Of[^[摜
  TWidth        : Integer;                    // g~Of[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;                     // ̓t@C

  threshold     : Double;                     // ͈͎w

  Gaussian : array[0..gaus - 1, 0..gaus - 1] of double;
  OPT           : integer;          // OPT = 1@wIeesij
                                    // OPT = 0@ʏ̂eesi[j
  TrimmingF     : boolean;          // g~OtO
  trimTop       : integer;          // g
  trimLeft      : integer;          // g
  trimHeight    : integer;          // g
  trimWidth     : integer;          // g
  TrimScale     : double;           // gXP[
  FopenF        : boolean;          // ŏ̌vZtO

  b_rl      : D2array;              // f[^]uƗpzij
  b_im      : D2array;              // f[^]uƗpzi)
  hsin_tbl  : array of Double;      // pSINvZpe[u
  hcos_tbl  : array of Double;      // pCOSvZpe[u
  vsin_tbl  : array of Double;      // pSINvZpe[u
  vcos_tbl  : array of Double;      // pCOSvZpe[u
  buf_x     : array of Double;      // Ɨpobt@ij
  buf_y     : array of Double;      // Ɨpobt@ij
  m_x       : M2array;              // f[^[̕בւrbg]with
  m_y       : M2array;              // f[^[̕בւrbg]Height

  FFrequency: int64;   // XgbvEHb`p NbN
  FStart:     int64;   // X^[gJE^[l
  FStop:      int64;   // XgbvJE^[l

const
  kr  = 0.299;                     // R PxϊW
  kg  = 0.587;                     // G PxϊW
  kb  = 0.114;                     // B PxϊW

  No1 = 0;
  No2 = 1;
  No3 = 2;
  No4 = 3;
  No5 = 4;

// XgbvEHb`X^[g
procedure TForm1.Start;
begin
  QueryPerformanceFrequency(FFrequency);      // NbN擾
  QueryPerformanceCounter(FStart);            // X^[gJE^[l
end;

// XgbvEHb`~
function TForm1.Stop: extended;
begin
  QueryPerformanceCounter(FStop);             // XgbvJE^[
  if FFrequency > 0 then                      // NbN̒l擾oĂ玞ԌvZ
    result := (FStop - FStart) * 1000 / FFrequency
  else result := -1;
end;

//------------------------
// ϔ{o
//------------------------
procedure TForm1.Imageout(Image: TBitmap);
var
  Rect0           : Trect;
  magnification   : Double;
  Check           : Integer;
  MW, MH          : Integer;
begin
  Val(magnificationEdit.Text,magnification,Check);
  if Check <> 0 then begin
    application.MessageBox('\{͂ɊԈႢ܂B','',0);
    exit;
  end;
  MW := round(Image.Width * magnification);
  MH := round(Image.Height * magnification);
  Rect0 := Rect(0, 0, MW, MH);
  Image1.Width := MW;
  Image1.Height := MH;
  Image1.Picture.Bitmap.SetSize(MW, MH);
  Image1.Canvas.StretchDraw(Rect0, Image);                // o͘gɕϔ{o
end;

//--- rvmtx --- Qf[^̓]u -------------------------------------------
//    a:        Q̓f[^1
//    b:        Qo̓f[^1
//    c;        Q̓f[^2
//    d;        Qo̓f[^2
//    xysize:   ,f[^
//    yxsize:   ,f[^
//-----------------------------------------------------------------------------
procedure TForm1.rvmtx(var a, b, c, d: D2array; xysize, yxsize: Integer);
var
  i, j: integer;
begin
  for i := 0 to yxsize - 1 do
    for j := 0 to  xysize - 1 do begin
      b[j, i] := a[i, j];
      d[j, i] := c[i, j];
    end;
end;

//--- birv --- f[^̕׊ -----------------------------------------------
//    a:       f[^̔z
//    length:  f[^
//    ex:      f[^Q̗ݏŗ^܂(2exj
//    b:       Ɨpobt@
//-----------------------------------------------------------------------------
procedure TForm1.birv(a: PDarray; length, ex: Integer; b: PDarray);
var
  i, ii, k, bit : Integer;
begin
  for i := 0 to length - 1 do begin
    ii := i;
    bit:= 0;
    for k := 0 to ex do begin
      bit := (ii and 1) or bit;
      if k = ex - 1 then break;
      bit := bit shl 1;
      ii := ii shr 1;
    end;
    b[i] := a[bit];
  end;
  for i := 0 to length - 1 do a[i] := b[i];
end;

//--No1- fft1core --- PeešvZ̊jɂȂ镔 ---------------------------
//    a_rl:       f[^io͌pj
//    a_im:       f[^io͌pj
//    ex:         f[^Q̗ݏŗ^܂(2exj
//    sin_tbl:    SINvZpe[u
//    cos_tbl:    COSvZpe[u
//-----------------------------------------------------------------------------
procedure TForm1.fft1core(a_rl, a_im: PDarray; length, ex: integer;
        sin_tbl, cos_tbl, buf: PDarray; inv: integer);
var
  i, j, k, w, j1, j2    : Integer;
  numb, lenb, timb      : Integer;
  xr, xi, nrml          : Double;
begin
  numb := 1;
  lenb := length;
  for i := 0 to ex - 1 do begin
    lenb := lenb div 2;
    timb := 0;
    for j := 0 to numb - 1 do begin
      w := 0;
      for k := 0 to lenb - 1 do  begin
        j1 := timb + k;
        j2 := j1 + lenb;
        xr := a_rl[j1] - a_rl[j2];
        xi := a_im[j1] - a_im[j2];
        a_rl[j1] := a_rl[j1] + a_rl[j2];
        a_im[j1] := a_im[j1] + a_im[j2];
        a_rl[j2] := xr * cos_tbl[w] - xi * sin_tbl[w];
        a_im[j2] := xr * sin_tbl[w] + xi * cos_tbl[w];
        w := w + numb;
      end;
      timb := timb + 2 * lenb;
    end;
    numb := numb * 2;
  end;
  birv(a_rl, length, ex, buf);      // f[^̕׊
  birv(a_im, length, ex, buf);      // f[^̕׊
  if inv = 1 then begin            // tB^[yыtϊ̓f[^[ŏZ܂
    nrml := 1.0 / length;
    for i := 0 to length - 1 do begin
      a_rl[i] := a_rl[i] * nrml;
      a_im[i] := a_im[i] * nrml;
    end;
  end;
end;

// ---No2---------------------V FFTvZ ------------------------------
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    length:  f[^[
//    inv:     ϊtO F = -1 ϊ F = 1 tϊ
//    sin_tbl, cos_tbl sin, cos e[u
//    m        ]qobt@
// -----------------------------------------------------------------
procedure TForm1.fft(a_rl, a_im: PDarray; var length, inv: integer;
                     sin_tbl, cos_tbl: PDarray; m: PMarray);
var
  I, J, nd, ns, L, arg, it, ib: integer;
  a, b, t : double;
begin
  nd := length div 2;           // f[^1/2
  ns := nd;                     // 2i̍ŏʒl
  while ns > 0 do begin         // 2i̍ŏʂ̒l0ɂȂ܂ŌJԂ
    L := 0;                     // L=0
    while L < length do begin   // L̒llength܂ŁA
      arg := m[L] shr 1;        // ]q=Ỏ]q̒l/2          m[0]͏0
      for it := L to L + ns - 1 do begin    // it̒lL̒lL+2i̍ŏʂ̒l܂ŌJԂ
        ib := it + ns;                      // ibit + 2i̍ŏʂ̒l
        a := a_rl[ib] * cos_tbl[arg] - a_im[ib] * sin_tbl[arg];
        b := a_im[ib] * cos_tbl[arg] + a_rl[ib] * sin_tbl[arg];
        a_rl[ib] := a_rl[it] - a;
        a_im[ib] := a_im[it] - b;
        a_rl[it] := a_rl[it] + a;
        a_im[it] := a_im[it] + b;
        m[it] := arg;           // m[it]ɉ]qۑ
        m[ib] := arg + nd;      // m[ib]ɉ]q+f[^1/2ۑ
      end;
      L := L + ns + ns;         // L̒l0n܂ŁA2~ŏʂ̒lstepŌJԂ
    end;
    ns := ns shr 1;             // 2i̍ŏʂ̒lJ艺
  end;
  if inv = 1 then begin                 // inv 1 gϊ -1 tϊ 2 tB^[
    t := 1 / length;
    for I := 0 to length - 1 do begin
      a_rl[I] := a_rl[I] * t;
      a_im[I] := a_im[I] * t;
    end;
  end;
  for I := 0 to length - 1 do begin     // f[^[̕בւrbg]
    if I < m[I] then begin
      J := m[I];
      t := a_rl[I];
      a_rl[I] := a_rl[J];
      a_rl[J] := t;
      t := a_im[I];
      a_im[I] := a_im[J];
      a_im[J] := t;
    end;
  end;
end;

// --No3----------------------V FFTvZ ------------------------------
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    length:  f[^[
//    inv:       ϊtO 0 ϊ 1 tϊ
// -----------------------------------------------------------------
procedure TForm1.fft3(a_rl, a_im: PDarray; length, ex, inv: integer;
                          sin_tbl, cos_tbl: PDarray);
var
  a, b: double;
  g, h, i, j, k, l , p, q: integer;
begin
  l := length;
  h := 1;                                   // 2^0
  for g := 1 to ex do begin
    l := l shr 1;                           // l 1/2
    k := 0;
    for q := 1 to h do begin
      p := 0;                               // ]q
      for i := k to l + k -1 do begin
        j := i + l;
        a := a_rl[i] - a_rl[j];
        b := a_im[i] - a_im[j];
        a_rl[i] := a_rl[i] + a_rl[j];
        a_im[i] := a_im[i] + a_im[j];
        if p = 0 then begin                 // ]q[͉Z̕KvȂ cos=1 sin=0
          a_rl[j] := a;
          a_im[j] := b;
        end
        else begin
          a_rl[j] := a * cos_tbl[p] + b * sin_tbl[p];
          a_im[j] := b * cos_tbl[p] - a * sin_tbl[p];
        end;
        p := p + h;                         // ]q+h
      end;
      k := k + l + l;                       // K + 2l
    end;
    h := h shl 1;                           // 2~n   2, 4, 8 ....
  end;
  j := length shr 1;                        // j = length / 2;
  for i := 1 to length - 1 do begin         // sbZqɂёւ
    k := length;
    if j < i then begin
      a := a_rl[i];
      a_rl[i] := a_rl[j];
      a_rl[j] := a;
      b := a_im[i];
      a_im[i] := a_im[j];
      a_im[j] := b;
    end;
    k := k shr 1;                         // k = k / 2
    while j >= k do begin
      j := j - k;
      k := k shr 1;                       // k = k / 2
      if k = 0 then break;
    end;
    j := j + k;
  end;
  if inv = 1 then begin                   // inv0gϊ f[^[ŏZ
    a := 1 / length;                      // Of[^[ǉꍇǉÕf[^[ŏZ
    for I := 0 to length - 1 do begin
      a_rl[I] := a_rl[I] * a;
      a_im[I] := a_im[I] * a;
    end;
  end;
end;

// --No4------------------------- FFT ---------------------------
//    a_rl:    f[^io͌pj

//    a_im:    f[^io͌pj
//    n:  f[^[
//    inv:       ϊtO 0 ϊ 1 tϊ
// -----------------------------------------------------------
procedure TForm1.fft4(n, inv: integer; xr, xi, sin_tbl, cos_tbl: PDarray);

var

  a, b: double;

  i, ia, ib, j, k, ns, arg : integer;

begin

  ns := n div 2;
  while ns >= 1 do begin
    arg := 0;
    j := 0;
    while j < n do begin
      k := n shr 2;                       // k = n / 4
      for ia := j to j + ns - 1 do begin
        ib := ia + ns;
        a := xr[ib] * cos_tbl[arg] - xi[ib] * sin_tbl[arg];
        b := xr[ib] * sin_tbl[arg] + xi[ib] * cos_tbl[arg];
        xr[ib] := xr[ia] - a;
        xi[ib] := xi[ia] - b;
        xr[ia] := xr[ia] + a;
        xi[ia] := xi[ia] + b;
      end;
      while k <= arg do begin             // [v
        arg := arg - k;
        k := k shr 1;                     // k = k / 2
        if k = 0 then break;
      end;
      arg := arg + k;
      j := j + ns + ns;
    end;
    ns := ns shr 1;                       // ns = ns / 2
  end;
  if inv = 1 then begin
    a := 1 / n;
    for i := 0 to n - 1 do begin
      xr[i] := xr[i] * a;
      xi[i] := xi[i] * a;
    end;
  end;
  j := 1;                                 // rbg]
  for i := 1 to n - 1 do begin
    if i <= j then begin
      ia := i - 1;
      ib := j - 1;
      a := xr[ia];
      b := xi[ia];
      xr[ia] := xr[ib];
      xi[ia] := xi[ib];
      xr[ib] := a;
      xi[ib] := b;
    end;
    k := n shr 1;                         // k = n / 2
    while k < j do begin
      j := j - k;
      k := k shr 1;                       // k = k / 2
    end;
    j := j + k;
  end;
end;

// ------------------------No5 FFTvZ ------------------------------
//    n  f[^[
//    xr:    f[^io͌pj
//    xi:    f[^io͌pj
// -----------------------------------------------------------------
procedure TForm1.fftNo5(var n, ex, inv: integer; xr, xi, sin_tbl, cos_tbl: PDarray);
var
  i, j, k, m, j1, j2, dn, w, arg: integer;
  t1, t2: double;
begin
  dn := n;
  w := 1;
  for i := 1 to ex do begin
    m := dn;
    dn := dn div 2;
    arg := 0;
    for j := 0 to dn - 1 do begin
      k := m;
      while k <= n do begin
        j1 := k - m + j;
        j2 := j1 + dn;
        t1 := xr[j1] - xr[j2];
        t2 := xi[j1] - xi[j2];
        xr[j1] := xr[j1] + xr[j2];
        xi[j1] := xi[j1] + xi[j2];
        xr[j2] := t1 * cos_tbl[arg] + t2 * sin_tbl[arg];
        xi[j2] := t2 * cos_tbl[arg] - t1 * sin_tbl[arg];
        k := k + m;
      end;
      arg := arg + w;
    end;
    w := w shl 1;                 // w = w * 2
  end;
  j := 1;
  dn := n div 2;
  for i := 1 to n - 1 do begin    // rbg]
    if i < j then begin
      j1 := i - 1;
      j2 := j - 1;
      t1 := xr[j2];
      t2 := xi[j2];
      xr[j2] := xr[j1];
      xi[j2] := xi[j1];
      xr[j1] := t1;
      xi[j1] := t2;
    end;
    k := dn;
    while k < j do begin
      j := j - k;
      k := k shr 1;               // k = k / 2
    end;
    j := j + k;
  end;
  if inv = 1 then begin
    t1 := 1 / n;
    for i := 0 to n - 1 do begin
      xr[i] := xr[i] * t1;
      xi[i] := xi[i] * t1;
    end;
  end;
end;

//--- cstb --- SIN,COSe[u쐬 --------------------------------------------
//    length:     f[^
//    inv:        1: ees, -1: tees
//    sin_tbl:    SINvZpe[u
//    cos_tbl:    COSvZpe[u
//-----------------------------------------------------------------------------
procedure TForm1.cstb(length: Integer; inv: Integer; var sin_tbl, cos_tbl: array of double);
var
  i : Integer;
  xx, arg : Double;
begin
  xx := - PI * 2.0 / length;
  if inv < 0 then xx := - xx;
  for i := 0 to length - 1 do begin
    arg := i * xx;
    sin_tbl[i] := sin(arg);
    cos_tbl[i] := cos(arg);
  end;
end;

//--- fft2 --- Qees̎s ---------------------------------------------
//   iGWidthCGHeightQׂ̂̏ꍇɌ܂j
//    a_rl:    f[^io͌pj
//    a_im:    f[^io͌pj
//    inv:    1: FesC-1: tFes
//  fft̃[`ɒln̂Ƀ|C^[ @@gpĂ܂
//  񎟌z̈snׂɎgpĂ܂B
//  ꎟ̔zn̂ |C^[ @ gpKv͂܂B
//  z̒ln̂𓝈ꂷ̂ɎgpĂ܂B
//-----------------------------------------------------------------------------
procedure TForm1.FFT2(var a_rl, a_im: D2array; inv: Integer);
var
 // zO[oϐɊ蓖Ăx肵܂
{
  b_rl      : D2array;              // f[^]uƗpzij
  b_im      : D2array;              // f[^]uƗpzi)
  hsin_tbl  : array of Double;      // pSINvZpe[u
  hcos_tbl  : array of Double;      // pCOSvZpe[u
  vsin_tbl  : array of Double;      // pSINvZpe[u
  vcos_tbl  : array of Double;      // pCOSvZpe[u
  buf_x     : array of Double;      // Ɨpobt@ij
  buf_y     : array of Double;      // Ɨpobt@ij
  m_x       : M2array;              // f[^[̕בւrbg]with
  m_y       : M2array;              // f[^[̕בւrbg]Height
}
  i, exw, exh        : Integer;
begin
  // z̊m
  if RadioGroup2.ItemIndex = No1 then begin
    SetLength(buf_x, GWidth);
    SetLength(buf_y, GHeight);
  end;
  if RadioGroup2.ItemIndex = No2 then begin
    SetLength(m_x, GWidth);
    SetLength(m_y, GHeight);
  end;
  SetLength(b_im, GWidth, GHeight);
  SetLength(b_rl, GWidth, GHeight);
  SetLength(hsin_tbl, GWidth);
  SetLength(hcos_tbl, GWidth);
  SetLength(vsin_tbl, GHeight);
  SetLength(vcos_tbl, GHeight);
  exw := round(ln(GWidth) / ln(2));
  exh := round(ln(GHeight) / ln(2));

  cstb(GWidth,  inv, hsin_tbl, hcos_tbl);     // pSIN,COSe[u쐬
  cstb(GHeight, inv, vsin_tbl, vcos_tbl);     // pSIN,COSe[u쐬
  // ̂ees
  for i := 0 to GHeight - 1 do begin
    if RadioGroup2.ItemIndex = No5 then
      fftNo5(GWidth, exw, inv, @a_rl[i][0], @a_im[i][0], @hsin_tbl[0], @hcos_tbl[0]);
    if RadioGroup2.ItemIndex = No4 then
      fft4(GWidth, inv, @a_rl[i][0], @a_im[i][0], @hsin_tbl[0], @hcos_tbl[0]);
    if RadioGroup2.ItemIndex = No3 then
      fft3(@a_rl[i][0], @a_im[i][0], GWidth, exw, inv, @hsin_tbl[0], @hcos_tbl[0]);
    if RadioGroup2.ItemIndex = No2 then
      fft(@a_rl[i][0], @a_im[i][0], GWidth, inv, @hsin_tbl[0], @hcos_tbl[0], @m_x[0]);
    if RadioGroup2.ItemIndex = No1 then
      fft1core(@a_rl[i][0], @a_im[i][0], GWidth, exw, @hsin_tbl[0], @hcos_tbl[0], @buf_x[0], inv);

  end;

  // Qf[^̓]u XY̒lւ܂
  // fft1corescanXɂoȂׂɍs܂
  rvmtx(a_rl, b_rl, a_im, b_im, GWidth, Gheight);

  // ̂ees
  for i := 0 to GWidth - 1 do begin
    if RadioGroup2.ItemIndex = No5 then
      fftNo5(GHeight, exh, inv, @b_rl[i][0], @b_im[i][0], @vsin_tbl[0], @vcos_tbl[0]);
    if RadioGroup2.ItemIndex = No4 then
      fft4(GHeight, inv, @b_rl[i][0], @b_im[i][0], @vsin_tbl[0], @vcos_tbl[0]);
    if RadioGroup2.ItemIndex = No3 then
      fft3(@b_rl[i][0], @b_im[i][0], GHeight, exh, inv, @vsin_tbl[0], @vcos_tbl[0]);
    if RadioGroup2.ItemIndex = No2 then
      fft(@b_rl[i][0], @b_im[i][0], GHeight, inv, @vsin_tbl[0], @vcos_tbl[0], @m_y[0]);
    if RadioGroup2.ItemIndex = No1 then
      fft1core(@b_rl[i][0], @b_im[i][0], GHeight, exh, @vsin_tbl[0], @vcos_tbl[0], @buf_y[0], inv);
  end;

  // Qf[^̓]u XY̒lւ܂
  // XYւĂ̂Ō֖߂܂
  rvmtx(b_rl, a_rl, b_im, a_im, Gheight, GWidth);

  // zO[oϐ͔̎zJ@ [J͕̎KvȂ
  Finalize(b_im);       // f[^]uƗpzij
  Finalize(b_rl);       // f[^]uƗpzi)
  Finalize(m_x);        // f[^[̕בւrbg]with
  Finalize(m_y);        // f[^[̕בւrbg]Height
  Finalize(hsin_tbl);   // pSINvZpe[u
  Finalize(hcos_tbl);   // pCOSvZpe[u
  Finalize(vsin_tbl);   // pSINvZpe[u
  Finalize(vcos_tbl);   // pCOSvZpe[u
  Finalize(buf_x);      // Ɨpobt@ij
  Finalize(buf_y);      // Ɨpobt@ij
end;

//-----------------------------
// KEVApf[^[̌vZ
//-----------------------------
function TForm1.SigumaMatSet: boolean;
const
  MatSize = gaus;
var
  X, Y  : integer;
  KS, Z : Double;
  CH    : integer;
  Total : Double;
  MDIV2 : integer;
  caution : Pchar;

  // VO}lKEXzľvZ
  function Maskdatacalc(X, Y : Integer; Z: Double): double;
  begin
    Result := 1 / 2 / pi / Z / Z * Exp(-(X * X + Y * Y) / 2 / Z / Z);    // }XNf[^[̌vZ
  end;

begin
  Result := False;
  Z  := 1;
  CH := 0;
  caution := '';
  if RadioGroup1.ItemIndex = Gaussians      then begin
    val(GaussEdit.Text, Z, CH);
    caution := 'Gaussian';
  end;
  if RadioGroup1.ItemIndex = Deconvolution  then begin
    val(SigumaEdit.Text, Z, CH);
    caution := 'Deconvolution';
  end;
  if RadioGroup1.ItemIndex = Unsharp        then begin
    val(UnsharpEdit.Text, Z, CH);
    caution := 'Unsharp';
  end;
  if CH <> 0 then begin
    application.MessageBox(' ͂ɊԈႢ܂B', caution, 0);
    exit;
  end;
  if Z <= 0 then begin
    application.MessageBox(' [ y [ȉł͂܂B', caution, 0);
    exit;
  end;
  if RadioGroup1.ItemIndex = Deconvolution then begin
    val(RangeEdit.Text, threshold, CH);
    caution := 'Deconvolution';
    if CH <> 0 then begin
      application.MessageBox('Deconv Range ͂ɊԈႢ܂B', caution, 0);
      exit;
    end;
    if threshold <= 0 then begin
      application.MessageBox('Deconv Range [yѕł͂܂B', caution, 0);
      exit;
    end;
    if threshold > 1 then begin
      application.MessageBox('Deconv Range 1𒴂ꍇ摜͂ȂȂ܂B', caution, 0);
      exit;
    end;
  end;
  // XgOObh̐ݒ
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  SigumaGrid.RowCount := MatSize + 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := - MDIV2 to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for X := - MDIV2 to MDIV2 do SigumaGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);

  // ВlɂAV[v}XNf[^[vZƕ\
  Total := 0;
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Maskdatacalc( X, Y, Z);
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // vvZ
      Total := Total + KS;
    end;
  // GaussiantB^[̒lϊ vlPɂȂ悤ɕϊ܂
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := Gaussian[X + MDIV2, Y + MDIV2] / Total;
      Gaussian[X + MDIV2, Y + MDIV2] := KS;
      // Obhɕ\
      SigumaGrid.Cells[X  + MDIV2 + 1, Y + MDIV2 + 1] := FloatTostrF(KS, ffFixed, 8,6);
    end;
  application.ProcessMessages;
  Result := True;
end;

//-------------------------------------------------------------------------------------------------
type
  TPrgbarry = array[0..0] of Trgbtriple;  // 24rbgJ[R[h@32rbgpTRGBQuadArray
  Prgbarray = ^TPrgbarry;                 // |C^[
                                          // z̃|C^[KvȂȂ̂ŁA1 [0..0]Ŗ肠܂B
var
  conv_real   : D2array;              // vVAAKEXtB^[p
  conv_image  : D2array;              // vVAAKEXtB^[p
  half_cw     : integer;              // tB^[1div2
  half_ch     : integer;              // tB^[1div2
  arBlu       : D2array;              // f[^io͌p)
  aiBlu       : D2array;              // f[^io͌p)
  r, i        : Double;
  PBA         : Prgbarray;            // RGBtriplez̃|C^[
  DI          : Integer;
  rdr         : Double;
  rdi         : Double;
  sttT, stpT  : TDateTime;            // interval^C}[
  stwT        : extended;             // stopwatch

//-----------------------------------------------------
// tB^[vZ
// ^C}[ő҂킹^C}[݂ŃtB^[vZ
//-----------------------------------------------------
procedure TForm1.MaskingBtnClick(Sender: TObject);
begin
  MaskingBtn.Enabled := False;
  FileOpenBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  fulbtn.Enabled := False;
  sourceBtn.Enabled := False;
  TrimmingBtn.Enabled := False;
  checkbox1.Enabled := False;
  if TrimmingF then TrimmingImage;
  Memo1.Clear;
  Memo1.Lines.Add('vZ');
  if checkbox1.Checked = False then begin
    sttT := Now;
    Memo1.Lines.Add(' Start ' + DateTimeToStr(sttT));
  end;
  Timer1.Enabled := True;         // ʕ\҂킹^C}[X^[g
end;

//-----------------------------------------------------
// {^\XV҂킹
// tB^[vZ
//-----------------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if checkbox1.Checked = True then Start;
  with RadioGroup1 do begin
    if ItemIndex = Laplacian  then LaplacianMask;
    if (ItemIndex = Gaussians)
      or (ItemIndex = Deconvolution)
      or (ItemIndex = Unsharp) then GaussianRoutine;
  end;
  FileSaveBtn.Enabled := True;
  FileOpenBtn.Enabled := True;
  RepaintBtn.Enabled := True;
  fulbtn.Enabled := True;
  sourceBtn.Enabled := True;
  if checkbox1.Checked = False then begin
    stpT := Now;
    Memo1.Lines.Add(' End   ' + DateTimeToStr(stpT));
    Memo1.Lines.Add(' interval sec ' + floatTostr(SecondsBetween(sttT, stpT)));
  end
  else begin
    stwT := Stop;
    memo1.Lines.Add('interval');
    memo1.Lines.Add('  ' + floatTostr(stwT) + 'msec');
  end;
  checkbox1.Enabled := True;
end;

//----------------------------
// ČvZ
//----------------------------
procedure TForm1.SigumaEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.RangeEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.UnsharpEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.GaussEditChange(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if radiogroup1.Enabled then MaskingBtn.Enabled := True;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  MaskingBtn.Enabled := True;
end;

//------------------------------------------
// vVAvZ
//------------------------------------------
procedure TForm1.LaplacianMask;
const
  // vVAtB^[
  cvnLap  = 3;
  convLap : array[0..cvnLap - 1, 0..cvnLap - 1] of double = ((1,  1,  1),
                                                             (1, -8,  1),
                                                             (1,  1,  1));
  MatSize = cvnLap;
var
  nx, ny, x, y: integer;
  MDIV2       : integer;
  KS          : double;
begin
  // XgOObh̐ݒ
  SigumaGrid.ColCount := MatSize + 1;
  SigumaGrid.RowCount := MatSize + 1;
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth + 1)  * (MatSize + 1) - 1;
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize + 1) - 1;
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := - MDIV2 to MDIV2 do SigumaGrid.Cells[0 , Y + MDIV2 + 1] := intTostr(Y);
  for X := - MDIV2 to MDIV2 do SigumaGrid.Cells[X + MDIV2 + 1,  0] := intTostr(X);
  // tB^[l\
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      KS := convLap[X + MDIV2, Y + MDIV2];
      // Obhɕ\
      SigumaGrid.Cells[X  + MDIV2 + 1, Y + MDIV2 + 1] := FloatTostrF(KS, ffFixed, 2,1);
    end;
  application.ProcessMessages;
  // z̊m
  // PC̐擪|C^[gp [V Lines, H Lines] ɂȂ܂
  setlength(conv_real, GHeight, GWidth);
  setlength(conv_image, GHeight, GWidth);
  setlength(arBlu, GHeight, GWidth);
  setlength(aiBlu, GHeight, GWidth);

  // tB^[z̃NA
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      conv_real[y, x] := 0.0;       // 
      conv_image[y, x] := 0.0;      // 
    end;
  // vVAtB^[̐ݒ
  half_cw := cvnLap div 2;
  half_ch := cvnLap div 2;
  for y := 0 to cvnLap - 1 do
    for x := 0 to cvnLap -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[ny][nx] := convLap[y][x];
    end;

  // gtB^[t[Gϊ܂
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  FFT2(conv_real, conv_image, 2);

  // 摜ǂݍ݃O[ϊ
  // QFFT̓̓f[^ɕϊ܂
  for y := 0 to Gheight - 1 do begin
    PBA := InputDBitmap.ScanLine[Y];
    for x := 0 to GWidth - 1 do begin
      // vVApOC摜  Pxϊ  
      arBlu[y, x] :=  Round(PBA[x].rgbtBlue * kb
                    + PBA[x].rgbtGreen      * kg
                    + PBA[x].rgbtRed        * kr);
      aiBlu[y, x] := 0.0;           // 
    end;
  end;

  // QFFTs 摜gɕϊ܂
  FFT2(arBlu, aiBlu, 1);

  // KEVA  vVA tB^[
  for x := 0 to GWidth - 1 do
    for y := 0 to GHeight - 1 do begin
      // tB^[̎{
      r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
      i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
      arBlu[y][x] := r;
      aiBlu[y][x] := i;
    end;

  // tFFTsāCtB^ꂽg摜ɖ߂܂
  FFT2(arBlu, aiBlu, -1);
  // ʂ摜f[^ɕϊ
  for Y := 0 to Sheight - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    for X := 0 to SWidth - 1 do begin
      DI := Round(arBlu[y][x]);
      if DI > 255 then DI := 255;
      if DI <   0 then DI := 0;
      PBA[x].rgbtBlue   := DI;
      PBA[x].rgbtGreen  := DI;
      PBA[x].rgbtRed    := DI;
    end;
  end;
  if FopenF then begin
    trimming_imageout(OutputBitmap);
    FopenF := False;
  end
  else Imageout(OutputBitmap);    // o͘gɕϔ{o

  Finalize(conv_real);
  Finalize(conv_image);
  Finalize(arBlu);
  Finalize(aiBlu);
end;

//------------------------------------------
// KEXtB^[ɂ{PvZ  Gaussian
// fR{[V        Deconvolution
// AV[v                Unsharp
//------------------------------------------
procedure TForm1.GaussianRoutine;
var
  nx, ny, x, y: integer;
  Step        : integer;
begin
  // KEVAtB^[f[^[̐
  if not SigumaMatSet then exit;

  // z̊m
  // PC̐擪|C^[gp [V Lines, H Lines] ɂȂ܂
  setlength(conv_real,  GHeight, GWidth);
  setlength(conv_image, GHeight, GWidth);
  setlength(arBlu, GHeight, GWidth);
  setlength(aiBlu, GHeight, GWidth);

  // tB^[z̃NA
  for y := 0 to GHeight - 1 do
    for x := 0 to GWidth - 1 do begin
      conv_real[y, x] := 0.0;         // 
      conv_image[y, x] := 0.0;        // 
    end;
  // gtB^[̐ݒ   lZbg
  half_cw := gaus div 2;
  half_ch := gaus div 2;
  for y := 0 to gaus - 1 do
    for x := 0 to gaus -1 do  begin
      nx := GWidth - half_cw + x;
      ny := Gheight - half_ch + y;
      if nx >= GWidth   then nx := nx - GWidth;
      if ny >= Gheight  then ny := ny - GHeight;
      conv_real[ny][nx] := Gaussian[y][x];
    end;

  // gtB^[t[Gϊ܂ RGBOFʂł
  // @tB^[̏ꍇAϊAf[^[ɂ鏜ZȂ悤ɂ܂
  FFT2(conv_real, conv_image, 2);

  // RGB PFƂFFŤvZ܂B
  for Step := 0 to 2 do begin
    // 摜ǂݍ݁CQFFT̓̓f[^ɕϊ܂
    for y := 0 to Gheight - 1 do begin
      PBA := InputDBitmap.ScanLine[Y];
      for x := 0 to GWidth - 1 do begin
      // J[pOF        
        case Step of
          0 :  arBlu[y, x] := PBA[x].rgbtBlue;
          1 :  arBlu[y, x] := PBA[x].rgbtGreen;
          2 :  arBlu[y, x] := PBA[x].rgbtRed;
        end;
        aiBlu[y, x] := 0.0;   // 
      end;
    end;

    // QFFTs 摜gɕϊ܂
    FFT2(arBlu, aiBlu, 1);

    // KEVA {JV@---------------------------
    if RadioGroup1.ItemIndex = Gaussians then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // tB^[̎{
          r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
          i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
          arBlu[y][x] := r;
          aiBlu[y][x] := i;
        end;
    end;
    //---------------------------------------------------

    // fR{[V -------------------------
    if RadioGroup1.ItemIndex = Deconvolution then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // fR{[VW
          rdr := abs(conv_real[y][x]);
          rdi := abs(conv_image[y][x]);
          // {JVƂ͋tȂ̂ŁAtɂ܂
          // threshold͒lꍇt̒l傫Ȃ肷̂Őlł
          // threshold̓[ł̏Z̖h~܂
          if rdr > threshold then rdr := 1 / conv_real[y][x]
                             else rdr := 0;
          if rdi > threshold then rdi := 1 / conv_image[y][x]
                             else rdi := 0;
          // fR{[V̐
          r := arBlu[y][x] * rdr - aiBlu[y][x] * rdi;
          i := arBlu[y][x] * rdi + aiBlu[y][x] * rdr;

          arBlu[y][x] := r;
          aiBlu[y][x] := i;
      end;
    end;
    //---------------------------------------------------

    // AV[v ---------------------------------
    if RadioGroup1.ItemIndex = Unsharp then begin
      for x := 0 to GWidth - 1 do
        for y := 0 to GHeight - 1 do begin
          // {P摜̐
          r := arBlu[y][x] * conv_real[y][x]  - aiBlu[y][x] * conv_image[y][x];
          i := arBlu[y][x] * conv_image[y][x] + aiBlu[y][x] * conv_real[y][x];
          // vZ
          r := arBlu[y][x] - r;
          i := aiBlu[y][x] - i;
          // f[^[ɍZ
          arBlu[y][x] := arBlu[y][x] + r;
          aiBlu[y][x] := aiBlu[y][x] + i;
        end;
    end;
    //---------------------------------------------------

    // tFFTsāCtB^ꂽg摜ɖ߂܂
    FFT2(arBlu, aiBlu, -1);

    // ʂ摜f[^ɕϊ
    for Y := 0 to Sheight - 1 do begin
      PBA := OutputBitmap.ScanLine[Y];
      for X := 0 to SWidth - 1 do begin
        DI := Round(arBlu[y][x]);
        if DI > 255 then DI := 255;
        if DI <   0 then DI := 0;
        case Step of
          0: PBA[x].rgbtBlue    := DI;
          1: PBA[x].rgbtGreen   := DI;
          2: PBA[x].rgbtRed     := DI;
        end;
      end;
    end;
  end;
  if FopenF then begin                       // t@COpen\
    trimming_imageout(OutputBitmap);         // o͘gɕϔ{o
    FopenF := False;
  end
  else Imageout(OutputBitmap);               // o͘gɕϔ{o

  Finalize(conv_real);
  Finalize(conv_image);
  Finalize(arBlu);
  Finalize(aiBlu);
end;

//--------------
// 摜̕\
//--------------
procedure TForm1.sourceBtnClick(Sender: TObject);
begin
  Imageout(InputDBitmap);               // o͘gɕϔ{o
end;

//----------------------------
// vZʂ̍ĕ\
//----------------------------
procedure TForm1.RepaintBtnClick(Sender: TObject);
begin
  Imageout(OutputBitmap);               // o͘gɕϔ{o
end;

//--------------------------------------------------
// Jt@C̉摜\
//--------------------------------------------------
procedure TForm1.trimming_imageout(Image: TBitmap);
begin
  if Image.Width >= Image.Height then begin
    Image1.Width := ImageHWC;
    image1.Height := round((ImageHWC) * image.Height / Image.Width);
  end
  else begin
    Image1.Height := ImageHWC;
    image1.Width := round((ImageHWC) * image.Width / Image.Height);
  end;
  Image1.Picture.Bitmap.SetSize(Image1.Width, image1.Height);
  Image1.Canvas.StretchDraw(Rect(0, 0, Image1.Width, image1.Height), Image);    // o͘gɕϔ{o
  magnificationEdit.Text := floatTostrF(Image1.Width / Image.Width, ffGeneral, 6, 4);
end;

//---------------------------------------------------------------
// 摜TCYc2^nƂ鎞A摜̏c𒴂Ȃʂ
// 摜TCYcݒ肵A摜o܂B
// o܂B
//---------------------------------------------------------------
procedure TForm1.TrimmingBtnClick(Sender: TObject);
begin
  Trimming;
end;

var
  Drawing       : Boolean;                    // }EXIg\tO
  Origin        : TPoint;                     // }EXX^[gʒu
  EndPoint      : TPoint;                     // }EXAbvʒu
  NewMove       : Boolean;                    // }EXVړ

//-------------------------------------------------------
// \ꂽ摜ɁA2^n TCY̎og\܂
//-------------------------------------------------------
procedure TForm1.Trimming;
var
  nx : integer;
begin
  if TrimmingF then begin
    if Drawing then begin
      Image1.Canvas.Pen.Mode := pmNotXor;                   // y[h Not Xor
      if not NewMove then begin
        Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop); // O̐
        Image1.Canvas.Pen.Mode := pmCopy;                   // y[hʏ
      end;
    end;
    TrimmingF := False;
    Drawing := False;
    exit;
  end;
  if not TrimmingF then TrimmingF := true;
  nx := 1;
  // f[^̂Qׂ̂vZ
  // 摜Ɠ傫2^n̉摜TCY擾
  repeat
    nx := nx * 2;
    if (nx <= SWidth)  then TWidth  := nx;            // g~O
    if (nx <= SHeight) then THeight := nx;            // g~O
  until (nx >= SWidth) and (nx >= SHeight);
  trimTop  := 0;                                      // g
  trimLeft := 0;                                      // g
  TrimScale   := Image1.Width / SWidth;
  trimHeight  := round(THeight * TrimScale);          // g
  trimWidth   := round(TWidth  * TrimScale);          // g
  Image1.Canvas.Brush.Style := bsClear;
  Image1.Canvas.Pen.Style := psSolid;
  Image1.Canvas.Pen.Color := clred;
  Image1.Canvas.Pen.Mode := pmNotXor;                 // y[h Not Xor
  Image1.Canvas.Rectangle (trimLeft, trimtop, trimWidth, trimHeight);
  Image1.Canvas.Pen.Mode := pmCopy;                   // y[hʏ
  NewMove := False;
  Drawing := True;
end;

//----------------------------------------------------------
// ogŕ\ꂽ摜o
// InputDBitmapɃZbg܂B
//----------------------------------------------------------
procedure TForm1.TrimmingImage;
var
  X, Y : integer;
  T, L : integer;
  PBB  : Prgbarray;
begin
  // 2^n̉摜TCYɐݒ
  InputDBitmap.Width := TWidth;
  InputDBitmap.Height := THeight;
  T := round(trimTop / TrimScale);
  L := round(trimLeft / TrimScale);
  if SWidth - (L + TWidth) < 0 then L := L - (SWidth - (L + TWidth));
  if SHeight - (T + THeight) < 0 then T := T - (SHeight - (T + THeight));
  for Y := T to T + THeight - 1 do begin
    PBA := OutputBitmap.ScanLine[Y];
    PBB :=  InputDBitmap.ScanLine[Y - T];
    for X := L to L + TWidth - 1 do begin
      PBB[X - L].rgbtBlue := PBA[X].rgbtBlue;
      PBB[X - L].rgbtGreen := PBA[X].rgbtGreen;
      PBB[X - L].rgbtRed := PBA[X].rgbtRed;
    end;
  end;
  GWidth := TWidth;
  GHeight := THeight;
  SWidth  := TWidth;
  SHeight := THeight;
  OutputBitmap.Width := GWidth;
  OutputBitmap.Height:= GHeight;
  // g~OÎŃtO
  TrimmingF := False;
  Drawing := False;
end;

//---------------------------------------------------------
// 摜ogړׂ̈̃}EX_Eɂݒ
//---------------------------------------------------------
procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if not TrimmingF then exit;
  Origin := Point(X, Y);                                                  // W̕ۑ
  NewMove := False;
  Drawing := True;
end;

//---------------------------------------------------------
// }EẌړɂogړ
//---------------------------------------------------------
procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  defX, defy : integer;
begin
  if Drawing and (Shift = [ssLeft]) then begin
    Image1.Canvas.Pen.Mode := pmNotXor;                                   // y[h Not Xor
    if not NewMove then begin
      Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop); // O̐
    end;
    EndPoint := point(X, Y);                                              // VWۑ
    defX := EndPoint.X - Origin.X;
    defY := EndPoint.Y - Origin.Y;
    if (trimLeft + defX >= 0) and (trimWidth + trimLeft + defX < image1.Width) then
      trimLeft := trimLeft + defX;
    if (trimtop + defY >= 0) and (trimHeight + trimTop + defY < image1.Height) then
      trimtop  := trimtop  + defY;
    Origin := Point(X, Y);
    Image1.Canvas.Rectangle(trimLeft, trimtop, trimWidth + trimLeft, trimHeight + trimTop);
    NewMove := False;
    Image1.Canvas.Pen.Mode := pmCopy;                                     // y[hʏ
  end;
end;

//------------------------------------------------
// t@C̃I[vƃOCf[^[̐
//------------------------------------------------
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  XF, YF      : Boolean;
  nx2         : integer;
begin
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnface;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute = true then                   // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        SHeight := WIC.Height;                                // 摜擾
        SWidth  := WIC.Width;                                 // 摜

        // OutputBitmapɌ摜ꎞۑ
        OutputBitmap.Width  := SWidth;
        OutputBitmap.Height := SHeight;
        OutputBitmap.Canvas.Draw(0, 0, WIC);     // rbg}bvɕ`tH[}bgϊ

        //---------------------------------------------------------------
        // 摜TCY傫 摜̃TCY Qnɐݒ
        // InputDBitmap Ɍ摜ɃRs[
        XF := False;
        YF := False;
        nx2 := 1;
        // f[^̂Qׂ̂vZ
        // 摜Ɠ傫2^n̉摜TCY擾
        repeat
          nx2 := nx2 * 2;
          if (nx2 >= SWidth) and (XF = False) then begin
            XF := True;
            GWidth := nx2;
          end;
          if (nx2 >= SHeight) and (YF = False) then begin
            YF := True;
            GHeight := nx2;
          end;
        until (nx2 >= SWidth) and (nx2 >= SHeight);

        // 2^n̉摜TCYɐݒ
        InputDBitmap.Width := GWidth;
        InputDBitmap.Height := GHeight;
        // Sʔݒ  Canvas 摜
        VRect := Rect(0, 0, GWidth, GHeight);
        InputDBitmap.Canvas.Brush.Style := bsSolid;
        InputDBitmap.Canvas.Brush.Color := clWhite;
        InputDBitmap.Canvas.FillRect(VRect);
        // TCY Qnɏ TCY̍Ȃ͔ɂȂ܂
        // WIC摜
        InputDBitmap.Canvas.Draw(0, 0, WIC);
        //--------------------------------------------------------------
      finally
        WIC.Free;                                   // TWICImage 
      end;
    end
    else exit;
  trimming_imageout(OutputBitmap);                  // o͘g킹Ăɕϔ{o

  MaskingBtn.Enabled := True;
//  sourceBtn.Enabled := True;
  radiogroup1.Enabled := True;
  TrimmingBtn.Enabled := True;
  checkbox1.Enabled := True;
  TrimmingF := False;
  FileSaveBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  fulbtn.Enabled := False;
  FopenF := True;
end;

procedure TForm1.FulBtnClick(Sender: TObject);
begin
  trimming_imageout(OutputBitmap);
end;

//------------------------------
// 摜̃t@Cւ̕ۑ
//------------------------------
procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(OutputBitmap);                                              // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.SaveTofile(Fname);                                                 // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

// ݒ
procedure TForm1.FormCreate(Sender: TObject);
begin
  top := (Screen.height - Height) div 2;
  left := (Screen.Width - Width) div 2;
  Timer1.Enabled := False;
  Timer1.Interval := 200;
  Image1.Width  := ImageHWC;
  Image1.Height := ImageHWC;
  ScrollBox1.Height := ImageHWC + ScrollBox1.BevelWidth * 4;
  ScrollBox1.Width  := ImageHWC + ScrollBox1.BevelWidth * 4;
  Image1.Top := 0;
  Image1.Left := 0;
  InputDBitmap  := TBitmap.Create;
  OutputBitmap  := TBitmap.Create;
  InputDBitmap.PixelFormat := pf24bit;
  OutputBitmap.PixelFormat := pf24bit;
  radiogroup1.Items.Add('Laplacian');
  radiogroup1.Items.Add('Gaussian');
  radiogroup1.Items.Add('Deconvolution');
  radiogroup1.Items.Add('Unsharp');
  radiogroup1.ItemIndex := 2;
  radiogroup2.Items.Add('No1');
  radiogroup2.Items.Add('No2');
  radiogroup2.Items.Add('No3');
  radiogroup2.Items.Add('No4');
  radiogroup2.Items.Add('No5');
  radiogroup2.ItemIndex := 1;

  radiogroup1.Enabled := False;
  MaskingBtn.Enabled := False;
  FileSaveBtn.Enabled := False;
  sourceBtn.Enabled := False;
  RepaintBtn.Enabled := False;
  fulbtn.Enabled := False;
  TrimmingBtn.Enabled := False;
  checkbox1.Enabled := False;
  OPT := 0;       // OPT = 1@wIeesij
end;

// I
procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;      // bitmap̊J
  OutputBitmap.Free;      // bitmap̊J
end;

end.
